<script setup lang="ts">
const props = defineProps({
  tableHeaders: {
    type: Array as () => { title: string }[],
    default: () => []
  },
  tableData: {
    type: Array,
    default: () => []
  },
  fixBtn: {
    type: Object,
    default: () => ({})
  }
})

const emit = defineEmits(['add', 'edit', 'delete'])

const fixBtnLength = computed(() => {
  const count = Object.keys(props.fixBtn)
    .filter((key) => !!props.fixBtn[key])
    .reduce((count, key) => count + 1, 0)
  let btnWidth = 0
  if (count) btnWidth = 96
  return btnWidth
})

const onCreate = (row: any) => {
  emit('add', row)
}
const onEdit = (row: any) => {
  emit('edit', row)
}
const onDelete = (row: any) => {
  emit('delete', row)
}
</script>
<template>
  <div>
    <table aria-describedby="table" class="basic-table table table-hover">
      <thead class="table-main">
        <tr class="thead-tr">
          <th
            v-for="(header, index) in props.tableHeaders"
            :key="index"
            class="font-zh-small-medium"
            scope="col"
          >
            {{ header.title }}
          </th>
          <th v-if="fixBtnLength" class="font-zh-p-regular" scope="col"></th>
        </tr>
      </thead>
      <tbody class="tbody-striped">
        <tr v-for="(row, rowIndex) in props.tableData" :key="rowIndex">
          <td
            v-for="(value, colIndex) in row"
            :key="colIndex"
            :class="{ 'text-color-gray-500': !value }"
            class="font-zh-small-regular"
          >
            {{ value ? value : 'N/A' }}
          </td>
          <td
            v-if="fixBtnLength"
            class="icons-column font-zh-small-regular operation-btn-list"
          >
            <div class="d-flex justify-content-center">
              <a
                v-if="fixBtn.add"
                class="icon-create-circle"
                href="javascript:void(0)"
                @click="onCreate(row)"
              ></a>
              <a
                v-if="fixBtn.edit"
                class="icon-edit"
                href="javascript:void(0)"
                @click="onEdit(row)"
              ></a>
              <a
                v-if="fixBtn.delete"
                class="icon-delete"
                href="javascript:void(0)"
                @click="onDelete(row)"
              ></a>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<style lang="scss" scoped></style>
